# Class: baruwa::db
#
#
class baruwa::db {
	include postgresql
	$sqlcheck = "\"SELECT proname FROM pg_proc where proname='crc32'\" |grep crc32"
	$sqlcheck2 = "\"SELECT proname FROM pg_proc where proname='dbvalue'\" |grep dbvalue"
	postgresql::createuser{"baruwauser":
	                        username => $baruwa_pgsql_user,
	                        passwd => $baruwa_pgsql_passwd,
	                        require => $baruwa_pgsql_host ? {
                                /(?i:127.0.0.1)/ => Service["postgresql"],
                                default => Package["postgresql"],
                            },
	                        }
	postgresql::createuser{"bayesuser":
	                        username => $baruwa_bayes_pgsql_user,
	                        passwd => $baruwa_bayes_pgsql_pass,
	                        require => $baruwa_pgsql_host ? {
                                /(?i:127.0.0.1)/ => Service["postgresql"],
                                default => Package["postgresql"],
                            },
	                        }
	postgresql::createdb{"baruwa":
	                        database => $baruwa_pgsql_db,
	                        owner => $baruwa_pgsql_user,
	                        require => $baruwa_pgsql_host ? {
                                /(?i:127.0.0.1)/ =>  [Exec["runsql-createuser-baruwauser"], Exec["utc-timezone"]],
                                default => Exec["runsql-createuser-baruwauser"],
                            },
	                        }
	postgresql::createlang{"plpgsql":
	                        language => "plpgsql",
	                        database => $baruwa_pgsql_db,
	                        require => Exec["runsql-createdb-baruwa"],
	                        }
	postgresql::createlang{"plpythonu":
	                        language => "plpythonu",
	                        database => $baruwa_pgsql_db,
	                        require => $baruwa_pgsql_host ? {
                                /(?i:127.0.0.1)/ =>  [Exec["runsql-createdb-baruwa"], Package["pg-server"]],
                                default => Exec["runsql-createdb-baruwa"],
                            },
	                        }
	postgresql::executesql{"functions.sql":
	                        username => 'postgres',
							password => $pgsql_password,
							database => $baruwa_pgsql_db,
							sql => template("baruwa/functions.sql.erb"),
							sqlcheck => $sqlcheck,
							require => [Exec["runsql-createlang-plpythonu"], Exec["runsql-createdb-baruwa"]],
							}
    postgresql::executesql{"upgrade.sql":
	                        username => $baruwa_pgsql_user,
							password => $baruwa_pgsql_passwd,
							database => $baruwa_pgsql_db,
							sql => template("baruwa/upgrade.sql.erb"),
							sqlcheck => $sqlcheck2,
							require => Exec["runsql-createdb-baruwa"],
							}

}