# Class: exim
#
#
class exim {
    $exim_user = $operatingsystem ? {
        /(?i:Debian|Ubuntu)/ => "Debian-exim",
        default => "exim",
    }
    $clam_user = $operatingsystem ? {
        /(?i:Debian|Ubuntu)/ => "clamav",
        default => "clam",
    }
    $clam_socket = $operatingsystem ? {
        /(?i:Debian|Ubuntu)/ => "/var/run/clamav/clamd.ctl",
        default => "/var/run/clamav/clamd.sock",
    }

    package { "exim":
        name => $operatingsystem ? {
            /(?i:Debian|Ubuntu)/ => "exim4-daemon-baruwa",
            default => "exim",
        },
        ensure => installed,
    }

    mailalias {"root":
        ensure => "present",
        recipient => "$baruwa_admin_email",
        target => "/etc/aliases",
    }

    package { ["sendmail-cf", "sendmail", "postfix"]:
        ensure => absent,
        require => Package["exim"],
    }

    service { "exim":
        name => $operatingsystem ? {
            /(?i:Debian|Ubuntu)/ => "exim4",
            default => "exim",
        },
        enable => false,
        hasrestart => true,
        hasstatus => true,
        require => Package["exim"],
    }

    file { "macros.conf":
        path => $operatingsystem ? {
           /(?i:Debian|Ubuntu)/ => "/etc/exim4/macros.conf",
           default => "/etc/exim/macros.conf",
        },
        content => template("exim/macros.conf.erb"),
        require => Package["exim"],
    }

    file { "exim.conf":
        path => $operatingsystem ? {
           /(?i:Debian|Ubuntu)/ => "/etc/exim4/exim4.conf",
           default => "/etc/exim/exim.conf",
        },
        content => template("exim/exim.conf.erb"),
        require => File["macros.conf"],
    }

    file { "exim_out.conf":
        path => $operatingsystem ? {
           /(?i:Debian|Ubuntu)/ => "/etc/exim4/exim_out.conf",
           default => "/etc/exim/exim_out.conf",
        },
        content => template("exim/exim_out.conf.erb"),
        require => File["exim.conf"],
    }

    if $operatingsystem in ['Ubuntu', 'Debian'] {
        file { "/etc/default/exim4":
            owner => "root",
            group => "root",
            mode => "0644",
            content => template("exim/default.erb"),
            require => Package["exim"],
            notify => Service["exim"],
        }
    }
}